///////////////////////////////////////////////////
// bookmark duplicate detector v0.0.1 by Paradox
// v0.0.5-0.0.7 modified for firefox 1.5.0 rc1 by Stefano Caselli
// Since v0.1.4 Maintainer is Stphane BERTIN
//	- Drag&drop support and 'parent folder',
//	- Bookmark this link,
//	- Bookmark All Tabs,
//	- Search duplicate URL
//TODO Be careful with URL url != url/ and so on !!!!

//Used to include only one time bookmark.js and avoid error message about already specified constant
try{
	if(ADD_BM_DIALOG_FEATURES) {}
} catch(e){
	var loader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
	    .getService(Components.interfaces.mozIJSSubScriptLoader);
	loader.loadSubScript("chrome://browser/content/bookmarks/bookmarks.js");
}

//Init Bookmarks.js Service
initServices();
initBMService();

// Replace BookmarksUtils method by our functions to detect duplicate URL
BookmarksUtils.insertAndCheckSelection = insertAndCheckURL; 
BookmarksUtils.addBookmark = addBookmarkURL; 

//gNC_NS is defined since Firefox 1.5 --> NC_NS === undefined
//NC_NS is defined for Firefox 1.0 --> gNC_NS === undefined
const gNCNS = "http://home.netscape.com/NC-rdf#";
var version = "1.5";
try {
	if (gNC_NS) version="1.5";
}
catch(e){
	version = "1.0";
}

// Used by drag&drop
function insertAndCheckURL (aAction, aSelection, aTarget, aTargetIndex)
{
	// Used to DEBUG
	var DEBUG = false;
	var DuplicatesBundle = document.getElementById('duplicates-strings');
	var isValid = BookmarksUtils.isSelectionValidForInsertion(aSelection, aTarget);
	if (!isValid) {
		SOUND.beep();
		return false;
	}
	if (aAction == "drag" || aAction == "paste"){
		var itemValue = BMDS.GetTarget(aSelection.item[0], RDF.GetResource(gNCNS+"URL"), true);
		var url = itemValue.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

		var isDuplicate = isBookmarked(url);
		if(isDuplicate) {
			var message = DuplicatesBundle.getString("alreadyIn-Folder")+"\n";
			message += isDuplicate.parents.join("\n")+"\n";
			message += DuplicatesBundle.getString("alreadyIn-Confirm");
			if(! confirm(message)) return false;
		}
	} else if (DEBUG) { alert("DEBUG: insertAndCheckURL + aAction: "+aAction);}

	BookmarksUtils.insertSelection(aAction, aSelection, aTarget, aTargetIndex);
	BookmarksUtils.flushDataSource();
	if (version == "1.5") BookmarksUtils.refreshSearch();
	return true;
}

// Verify if the specified URL is already in Bookmark
// If URL already in Bookmark function return an Array of Parent folder
function URLConstructor(){
	this.parents = new Array();
	this.RDFnodes = new Array();
}
function isBookmarked(url)
{
	var DuplicatesBundle = document.getElementById('duplicates-strings');

	if ( ! BMSVC || ! BMDS || ! RDF || ! gNCNS )
	{
		alert(DuplicatesBundle.getString("flagrantError-Alert"));
		return false; 
	}

	var urlArcID   = RDF.GetResource(gNCNS+"ID");
	var urlLiteral= RDF.GetLiteral(url);
	var bmResource = BMSVC.GetSources(RDF.GetResource(gNCNS+"URL"), urlLiteral, true);
// TODO --> replace Array.prototype by a constructor; URLFound=new{ this.parents = new Array(); ...}
//var myContainer = new Container('abc');
// then myContainer.member contains 'abc'.
//function Container(param) {
    //this.member = param;
//}

	var count = 0;
	//var URLFound = new Array();
	//Array.prototype.parents = new Array();
	//Array.prototype.resources = new Array();
	//Array.prototype.RDFnodes = new Array();
	var URLFound = new URLConstructor();
	while (bmResource.hasMoreElements()) {
		var DuplicateURLresource=bmResource.getNext();
		var URLParent = BMSVC.getParent(DuplicateURLresource);
		if(URLParent) {
			//URLFound.parents[count] = BookmarksUtils.getProperty(URLParent.Value,gNCNS+"Name");
			URLFound.parents[count] = findPath(DuplicateURLresource);
			//URLFound.resources[count] = DuplicateURLresource;
			URLFound.RDFnodes[count] = BMDS.GetTarget(DuplicateURLresource.QueryInterface(kRDFRSCIID), urlArcID, true);
			//var Node = BMDS.GetTarget(DuplicateURLresource.QueryInterface(kRDFRSCIID), urlArcID, true);
			//alert("RDF Node"+Node.Value);
			count++;
		}
	}

	if (count>0) return URLFound;
	return false;
}

// Replace addBookmark to verify if URL is duplicated
function addBookmarkURL (aURL, aTitle, aCharset, aIsWebPanel, aDescription)
{
	var DuplicatesBundle = document.getElementById('duplicates-strings');
	var dArgs = {
		name: aTitle,
		url: aURL,
		charset: aCharset,
		bWebPanel: aIsWebPanel,
		description: aDescription
	}

	var isDuplicate = isBookmarked(aURL);
	if(isDuplicate) {
		var message = DuplicatesBundle.getString("alreadyIn-Folder")+"\n";
		message += isDuplicate.parents.join("\n")+"\n";
		message += DuplicatesBundle.getString("alreadyIn-Confirm");
		if(! confirm(message)) return false;
	}

    if(version == "1.5") {
		return openDialog("chrome://browser/content/bookmarks/addBookmark2.xul", "", ADD_BM_DIALOG_FEATURES, dArgs);
	} else if (version == "1.0") {
		return openDialog("chrome://browser/content/bookmarks/addBookmark2.xul", "", "centerscreen,chrome,dialog,resizable,dependent", aTitle,aURL,null,aCharset,null,null,aIsWebPanel);
	}

}

/*
timeA = new Date();
// Statements here to take some action.
timeB = new Date();
timeDifference = timeB - timeA;
*/
// Function used to search in ALL Bookmarks which URL are duplicated
function searchDuplicateURL ()
{
	var DuplicatesBundle = document.getElementById('duplicates-strings');
	var urlArc = RDF.GetResource(gNCNS+"URL");
	var FeedArc = RDF.GetResource(gNCNS+"FeedURL");
	//var urlArcID   = RDF.GetResource(gNCNS+"ID");

	try {
		var AllBookmarksResources = BMDS.GetAllResources();

	} catch(err) {
		Components.utils.reportError(err);
	}

	var containerChildren = AllBookmarksResources;
	var AllURLs = new Array(), URLDuplicates = new Array();
	var AllURLsTotal = 0, URLdupNum = 0;

	while (containerChildren.hasMoreElements()) {
		var urlRes = containerChildren.getNext().QueryInterface(kRDFRSCIID);
		var target = BMDS.GetTarget(urlRes, urlArc, true);
//Bookmark{URL}
//Livemark{URL, FeedURL} So livemark also detected by Bookmark target.
		//var Node = BMDS.GetTarget(urlRes, urlArcID, true);
		//var targetFeed = BMDS.GetTarget(urlRes, FeedArc, true); //Livemark's Folders
		//if (targetFeed) target = targetFeed;
		var aParent = BMSVC.getParent(urlRes);
		if (aParent) var ptype = BookmarksUtils.resolveType(aParent);
		//if (ptype == "Livemark") alert("URL is Livemark "+urlRes.Value);
		//if ((target && ptype != "Livemark")|| targetFeed)
		if (target && ptype != "Livemark"){
			var url = target.QueryInterface(kRDFLITIID).Value;
			//if (targetFeed) alert("TargetFeed "+targetFeed.QueryInterface(kRDFLITIID).Value);
			if(version == "1.5"){
				if (AllURLs.indexOf(url) == -1){
					AllURLs[AllURLsTotal] = url;
				} else {
					if (URLDuplicates.indexOf(url) == -1) {
						URLDuplicates[URLdupNum] = url;
						URLdupNum++;
					}
				}
			} else { //version == "1.0"
				AllURLs[AllURLsTotal] = url;
			}
			AllURLsTotal++;
		}
	
	}
	if  (version == "1.0"){
		var AllURLnum = AllURLs.length, isDuplicate = false;
		for (var countB = 0; countB < AllURLnum;countB++){
			isDuplicate=isBookmarked(AllURLs[countB]);
			if (isDuplicate && isDuplicate.parents.length > 1){
				var alreadyIN = false;
				for (var count=0, URLnum=URLDuplicates.length; count<URLnum; count++){
					if (URLDuplicates[count] == AllURLs[countB]) alreadyIN = true;
				}
				if (!alreadyIN){
					URLDuplicates[URLdupNum] = AllURLs[countB];
					URLdupNum++;
				}
			}
		}
	}

	URLDuplicates.sort();
	if (URLdupNum >0 ){
		var message ="";
		try {
			//message = DuplicatesBundle.getFormattedString("SearchDup", [URLDuplicates.length, AllURLsTotal, eval(countC+1), numpage]);
			message = DuplicatesBundle.getFormattedString("SearchDup", [URLdupNum, AllURLsTotal, "1", "1"]);
		} catch (e) {
			message = DuplicatesBundle.getString("SearchDup-TotalURL")+" "+URLdupNum+" "+DuplicatesBundle.getString("SearchDup-OutOF")+" "+AllURLsTotal+" ";
			message += DuplicatesBundle.getString("SearchDup-ListOF")+" "+eval(countC+1)+"/"+numpage+"\n";
		}
		openDialog("chrome://duplicates/content/DuplicatesFound.xul", "DupFound", "chrome,alwaysRaised,resizable,centerscreen", URLDuplicates,message);
	} else { alert(DuplicatesBundle.getString("SearchDup-none")); }
}


// Replace function addBookmarkForTabBrowser in browser.js
// Add support for isBookmarked()
function addBookmarkForTabBrowser(aTabBrowser, aBookmarkAllTabs, aSelect)
{
	var DuplicatesBundle = document.getElementById('duplicates-strings');
	var tabsInfo = [];
	var currentTabInfo = { name: "", url: "", charset: null };
	if (version == "1.0" && aBookmarkAllTabs) {
		aSelect = aBookmarkAllTabs;
		if (aSelect) aBookmarkAllTabs = true;
	}

	const activeBrowser = aTabBrowser.selectedBrowser;
	const browsers = aTabBrowser.browsers;
	for (var i = 0, j = 0; i < browsers.length; ++i) {
		var webNav = browsers[i].webNavigation;
		var url = webNav.currentURI.spec;
		var name = "";
		var charSet, description;
		try {
			var doc = webNav.document;
			name = doc.title || url;
			charSet = doc.characterSet;
			if (version == "1.5") description = BookmarksUtils.getDescriptionFromDocument(doc);
		} catch (e) {
			name = url;
		}

		var isDuplicate = isBookmarked(url);
		if(isDuplicate) {
			var messageURL = DuplicatesBundle.getString("followingURL")+"\n";
			messageURL += url+"\n";
			messageURL += DuplicatesBundle.getString("inFolder")+"\n";
			messageURL += isDuplicate.parents.join("\n")+"\n";
			messageURL += DuplicatesBundle.getString("alreadyIn-Confirm");

			var message = DuplicatesBundle.getString("alreadyIn-Folder")+"\n";
			message += isDuplicate.parents.join("\n")+"\n";
			message += DuplicatesBundle.getString("alreadyIn-Confirm");

			//var answerOK = confirm(message) || false;
			if(aBookmarkAllTabs) {
				if (! confirm(messageURL)) continue;
			} else if (browsers[i] == activeBrowser) {
				if (! confirm(message)) return false;
			}
		}

		tabsInfo[j] = { name: name, url: url, charset: charSet, description: description };
		if (browsers[i] == activeBrowser) currentTabInfo = tabsInfo[j];
		j++;
	}

	if (tabsInfo.length == 0) {
		alert (DuplicatesBundle.getString("NoNewURL"));
		return false;
	}

	var dialogArgs = currentTabInfo;
	if (version == "1.5" && aBookmarkAllTabs) {
		dialogArgs = { name: gNavigatorBundle.getString("bookmarkAllTabsDefault") };
		dialogArgs.bBookmarkAllTabs = true;
	}


	dialogArgs.objGroup = tabsInfo;
	if(version == "1.5") {
		return openDialog("chrome://browser/content/bookmarks/addBookmark2.xul", "", ADD_BM_DIALOG_FEATURES, dialogArgs);
	} else if (version == "1.0") {
		return openDialog("chrome://browser/content/bookmarks/addBookmark2.xul", "", "centerscreen,chrome,dialog,resizable,dependent", currentTabInfo.name, currentTabInfo.url, null, currentTabInfo.charset, "addGroup" + (aSelect ? ",group" : ""), tabsInfo);


	}
}
// Return a chain of URL Parent Folder Name 
function findPath(URLresource){
	var ParentResource = URLresource;
	//var ParentArray = new Array();
	var PathArray = new Array();
	var boucle = true, ParentName;

	while (boucle){
		ParentResource = BMSVC.getParent(ParentResource);
		if (ParentResource) {
			ParentName = BookmarksUtils.getProperty(ParentResource.Value,gNCNS+"Name");
			//ParentArray.push(ParentResource);
			if (ParentName) PathArray.push(ParentName);
		} else {
			boucle = false;
		}
	}
	PathArray.reverse();
	//return PathArray.join("-->");
	return PathArray.join(" > ");
}


//Add BookmarkDD menuitem in Bookmarks Menu
//Work with addEventListener but function is called for each XUL window opened !!
// NOT USED
/*
function addMenu()
{
    try{
      var menu=document.getElementById("bookmarks-menu");
	if(!menu) return;
      var popup=menu.firstChild;
      var sep=popup.getElementsByTagName("menuseparator")[0];
    }catch(e){alert(e); return;}
  
    var  element = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
    element.setAttribute("id", "BookmarkDD");
    element.setAttribute("label", "Search Duplicate Now");
    element.setAttribute("accesskey", "Z");
    element.setAttribute("oncommand", "searchDuplicateURL();");
    popup.insertBefore(element,sep);

}
//Event Listeners
//window.addEventListener("load", addMenu, false);
*/

//Execute this function only on Option panel unload
function VerifyMenuItemStatus(){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		.getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		// |win| is [Object ChromeWindow] (just like |window|), do something with it
		var BDD=win.document.getElementById("BookmarkDD-context-menu");
		if(BDD) {
			//alert("Bdd found: "+BDD);
			if(!UserPrefs.getPref("bool","Menu.addLink")) {
				BDD.setAttribute('hidden',true);
			} else {
				BDD.setAttribute('hidden',false);
			}
		}
	}

}

function BCreateMenuContext(){
	try{
		var menu=document.getElementById("bookmarks-menu");
		if(!menu) return; //We are not in windowsID="main-window"
		if(!UserPrefs.getPref("bool","Menu.addLink")) document.getElementById("BookmarkDD-context-menu").setAttribute('hidden',true);
		//alert("Menu.addlink "+UserPrefs.getPref("bool","Menu.addLink"));
	}catch(e){alert(e); return;}

}

// Event Listener to add/Remove BookmarkDD menu item within Bookmarks menu
//window.addEventListener("load", BCreateMenuContext, false);
